#if !defined HAVE_PERMROT_H__
#define      HAVE_PERMROT_H__


#include "comb/printperm.h"
#include "fxttypes.h"


class perm_rot
// All permutations, by rotations (cyclic shifts).
// Algorithm of G.G.Langdon Jr., as given in Knuth
// Array x[] unused here (commented out)!
{
public:
    ulong n_;
    ulong k_;
//    ulong *x_;  // unused here
    ulong *a_;  // permutation of n elements

public:
    perm_rot(ulong n)
        : n_(n)
    {
//        x_ = new ulong[n_];
        a_ = new ulong[n_];
        first();
    }

    ~perm_rot()
    {
//        delete [] x_;
        delete [] a_;
    }

    void first()
    {
        for (ulong k=0; k<n_; ++k)  a_[k] = k;
//        for (ulong k=0; k<n_; ++k)  x_[k] = k;
        k_ = n_;
    }

    ulong next()
    {
        k_ = n_;
        do
        {
            ulong a0 = a_[0];
            ulong k1 = k_ - 1;
            for (ulong k=0; k<k1; ++k)  a_[k] = a_[k+1];
            a_[k1] = a0;

//            if ( a_[k1] != x_[k1] )  break;
            if ( a_[k1] != k1 )  break;
        }
        while ( 0 != --k_ );

        return k_;
    }

    ulong current()  const  { return k_; }

    const ulong *data()  const  { return a_; }

    void print(const char *bla, bool dfz)  const
    // If dfz is true then Dots are printed For Zeros.
    { print_perm(bla, data(), n_, dfz); }
};
// -------------------------


#endif  // !defined HAVE_PERMROT_H__
