#if !defined  HAVE_SUBSET_DELTALEX_H__
#define       HAVE_SUBSET_DELTALEX_H__

#include "fxttypes.h"

class subset_deltalex
// Subsets in lexicographic order for delta sets
{
public:
    ulong *d_;  // subset as delta set
    ulong n_;   // subsets of the  n-set {0,1,2,...,n-1}

public:
    subset_deltalex(ulong n)
    {
        n_ = n;
        d_ = new ulong[n+1];
        d_[n] = 0;  // sentinel
        first();
    }

    ~subset_deltalex()
    { delete [] d_; }

    void first()
    { for (ulong k=0; k<n_; ++k)  d_[k] = 0; }

    bool next()
    {
        ulong k = 0;
        while ( d_[k]==1 )  { d_[k]=0;  ++k; }

        if ( k==n_ )  return false;
        else
        {
            d_[k] = 1;
            return true;
        }
    }

    const ulong * data()  const { return d_; }
};
// -------------------------


#endif  // !defined HAVE_SUBSET_DELTALEX_H__
