
#include "bits/bit2adic.h"

#include "fxttypes.h"
#include "bits/bitsperlong.h"
#include "bits/printbin.h"

#include "demo/nextarg.h"
#include "jjassert.h"

#include "fxtio.h"
#include "fxtiomanip.h"


//% 2-adic inverse and square root.

ulong pn = 32;  // Number of bits shown, pn<=BITS_PER_LONG


static void show2adic(ulong x)
{
    print_bin_nn("    x   = ", x, pn);
    cout << "  = " << setw(4) << (long)x;

    if ( x&1 )
    {
        ulong i = inv2adic(x);  // inverse
        cout << endl;
        print_bin_nn("    inv = ", i, pn);
        jjassert( 1UL == x*i );
    }

    do
    {
        ulong r = sqrt2adic(x);
        if ( r*r != x )   break;

        cout << endl;
        print_bin_nn("   sqrt = ", r, pn);
//        print_bin_nn("   x = ", x, pn);
    }
    while ( 0 );

    cout << endl;
    cout << endl;
}
// -------------------------


int
main(int argc, char **argv)
{
    ulong ldn = 6;
    NXARG(ldn, "max n:=2**ldn-1");
    NXARG(pn, "Number of bits shown");
    ulong mq = 3;
    NXARG(mq, "");

    const ulong n = 1UL << ldn;
    for (ulong k=1; k<n; ++k)
    {
        ulong x = k;
        if ( mq & 1 ) show2adic(x);
        if ( mq & 2 )  show2adic(-x);
    }

    cout << endl;
    return 0;
}
// -------------------------


/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bit2adic-demo.cc"
/// End:

