
#include "bits/bitlex.h"
#include "bits/printbitset.h"

#include "fxttypes.h"
#include "fxtiomanip.h"
#include "bits/printbin.h"
#include "bits/bitsperlong.h"

//#include "bits/graycode.h"

#include "demo/nextarg.h"


//% Generating binary words in subset-lexicographic order.

int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "n-bit binary words");
    ulong m = 1UL<<n;
    bool bq = 0;
    NXARG(bq, "Whether to also print backwards list");
    const ulong rq = n;

    ulong x = 1UL<<(n-1);  // first subset
    ulong ct = 0;
    do
    {
        ++ct;
        cout << setw(2) << ct << ":  ";
        print_bin_nn("", x, n);
        cout << "  = " << setw(2) << x;
        print_bit_set("  ", x, rq);
        cout << endl;
    }
    while ( (x=next_lexrev(x)) );


    cout << endl;

    if ( bq )
    {
//        cout << " ... and backward (fixed point marked with '*'):" << endl;
        ct = 1;
        while ( (x = prev_lexrev(x)) < m )
        {
            cout << setw(2) << ct << ":  ";
            print_bin_nn("", x, n);
            cout << "  = " << setw(2) << x;
            print_bit_set("  ", x, rq);

//            print_bin_nn("  ", negidx2lexrev(ct), n+1);  // == x
//            ulong z = x ^ next_lexrev(x);
//            print_bin_nn("  ", z, n+1);
//            if ( is_lexrev_fixed_point(x) )  cout << " *";
            ++ct;
            cout << endl;
        }
    }

    return  0;
}
// -------------------------

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bitlex-demo.cc"
/// End:

