
#include "bits/bitsequency.h"

#include "bits/printbin.h"

#include "demo/nextarg.h"
#include "fxttypes.h"

#include "fxtio.h"
#include "jjassert.h"


//% Generating bit sets of given sequency.

int
main(int argc, char **argv)
{
    ulong pd = 6;
    NXARG(pd, "Word size in bits");

    ulong Ct = 1;
    for (ulong i=0; i<pd ; ++i)
    {
        ulong c = first_sequency(i+1);

        cout << endl;
        cout << "   sequency = " << bit_sequency(c) << endl;
        print_bin_nn(" ", c, pd);
//        print_bin_nn("    ", c ^ 0xaaaaaaaaUL, pd);  // negated sequency
        cout << endl;

        ulong ct = 0;
        do
        {
            ++ct;
            c = next_sequency(c);

            // special condition for pd-bit demo:
            if ( c>=(1UL<<pd) )  break;
            print_bin_nn(" ", c, pd);
//            print_bin_nn("    ", c ^ 0xaaaaaaaaUL, pd);  // negated sequency
            cout << endl;
            jjassert( bit_sequency(c)==(i+1) );
        }
        while ( c );

        Ct += ct;
        cout << " ct == " << ct;
        cout << "    Ct == " << Ct;
        cout << endl;
    }

    cout << endl;

    return 0;
}
// -------------------------

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bitsequency-demo.cc"
/// End:

