
#include "comb/combination-altminchange.h"

#include "bits/revbin.h"

#include "bits/printbin.h"
#include "jjassert.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "fxtiomanip.h"

#include "demo/nextarg.h"


//% Generating (n choose k) combinations (alternative) minimal-change order.


void
foo(ulong n, ulong k)
{
    cout << " n = " << n << "  k = " << k << ":" << endl;
    jjassert( n>0 );
    jjassert( k>0 );
    jjassert( n>=k );

    ulong ct = 0;
    combination_altminchange C(n, k);

    C.first();
//    C.last();
    do
    {
        ulong bits = revbin( ~C.bits_, n);  // reversed and negated
        cout << "   ";
        for (long k=n-1; k>=0; --k)  cout << ((bits>>k)&1 ? '1' : '.');

        cout << "   [ " << C << " ]  ";

        cout << "  swap: (" << C.sw1_ << ", " << C.sw2_ << ") ";

        cout << "  #" << setw(3) << ct;

        ++ct;
        cout << endl;
    }
    while ( C.next() );
//    while ( C.prev() );

    cout << endl;
    cout << endl;
}
// -------------------------

int
main(int argc, char **argv)
{
    ulong n = 7;
    NXARG(n,"combinations (n choose k): n>0");
    ulong k = 4;
    NXARG(k,"0<k<=n");

    foo(n, k);

    return 0;
}
// -------------------------

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/combination-altminchange-demo.cc"
/// End:

