
#include "comb/combination-colex.h"

#include "comb/printset.h"

#include "jjassert.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "fxtiomanip.h"

#include "demo/nextarg.h"

//% Generating all combinations in co-lexicographic order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 7, k = 4;
    NXARG(n, "Combinations (n choose k) in co-lexicographic order:  n>0");
    NXARG(k, " 0 < k <= n");
    ulong ct = 0;
    combination_colex C(n, k);

    do
    {
#ifndef TIMING
        cout << endl;
        C.print_set("    ");
        C.print_deltaset("    ");
        cout << "    #" << setw(3) << ct;
#endif // TIMING
        ++ct;
    }
    while ( C.next() );
    cout << endl;
    cout << " ct = " << ct << endl;

    return 0;
}
// -------------------------

/*
Timing:
% time ./bin 32 20
arg 1: 32 == n  [Combinations (n choose k):  n>0]  default=7
arg 2: 20 == k  [ 0 < k <= n]  default=4
 ct = 225792840
./bin 32 20  1.51s user 0.01s system 99% cpu 1.518 total
 ==> 148,743,636 comb/sec

 % time ./bin 32 12
arg 1: 32 == n  [Combinations (n choose k):  n>0]  default=7
arg 2: 12 == k  [ 0 < k <= n]  default=4
 ct = 225792840
./bin 32 12  1.14s user 0.01s system 100% cpu 1.155 total
 ==> 195,491,636 comb/sec
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/combination-colex-demo.cc"
/// End:

