
#include "comb/combination-minchange.h"

#include "fxttypes.h"
#include "jjassert.h"
//#include "comb/printset.h"

#include "bits/printbin.h"
#include "fxtio.h"
#include "fxtiomanip.h"

#include "demo/nextarg.h"

//% Generating all combinations in minimal-change order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 7, k = 4;
    NXARG(n, "Combinations (n choose k)");
    NXARG(k,"");

    ulong ct = 0;
    combination_minchange C(n, k);

    C.first();
//    C.last();
    do
    {
#ifndef TIMING
        ulong bits = C.bits_;
        cout << "   ";
        for (long j=n-1; j>=0; --j)  cout << ((bits>>j)&1 ? '1' : '.');
        cout << "   [";
        for (ulong j=0; j<k; ++j) { cout.width(3); cout << C.x_[j]; }
        cout << " ]  ";
        cout << "  swap: (" << C.sw1_ << ", " << C.sw2_ << ") ";
        cout << "  #" << setw(3) << ct;
        cout << endl;
#endif // TIMING
        ++ct;
    }
    while ( C.next() );
//    while ( C.prev() );

    cout << " ct = " << ct << endl;

    return 0;
}
// -------------------------

/*
Timing:
 % time ./bin 32 20
arg 1: 32 == n  [Combinations (n choose k)]  default=7
arg 2: 20 == k  []  default=4
 ct = 225792840
./bin 32 20  32.09s user 0.17s system 99% cpu 32.324 total
 ==> 6,985,300 comb/sec (slow!)
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/combination-minchange-demo.cc"
/// End:

