
#include "comb/partition-rec.h"

#include "fxttypes.h"

#include "jjassert.h"
#include "demo/nextarg.h"

#include "fxtio.h"

//% Generate all integer partitions, recursive algorithm.

//#define TIMING // uncomment to disable printing

void
print_part(ulong n)
{
    partition_rec pp(n);
    ulong ct = 0;

    while ( pp.next() < n )
    {
#ifndef TIMING
        cout << "    #" << setw(2) << ct << ": ";
        cout << setw(4) << pp.x_ << " == ";
        pp.print2();
        cout << "  ==  ";
        pp.print();
        cout << endl;
#endif // TIMING
        ++ct;
    }
    cout << " " << n << ":  ct=" << ct << endl;
    cout << endl;
}
// -------------------------

int
main(int argc, char **argv)
{
    ulong n = 6;
    NXARG(n, "Partitions of n");

    partition_rec pp(n);
    ulong ct = 0;

    do
    {
#ifndef TIMING
        cout << "    #" << setw(2) << ct << ": ";
        cout << setw(4) << pp.n_ << " == ";
        pp.print2();
        cout << "  ==  ";
        pp.print();
        cout << endl;
#endif // TIMING
        ++ct;
    }
    while ( pp.next() < n );

    cout << " " << n << ":  ct=" << ct << endl;
    cout << endl;

    return 0;
}
// -------------------------

/*
Timing:
 % time ./bin 100
arg 1: 100 == nmax  [Shown all partitions for n<=nmax]  default=6
arg 2: 30 == cmax  [Count number of partitions for n<=cmax]  default=30
 100:  ct=190569292
./bin 100  10.55s user 0.04s system 99% cpu 10.615 total
 ==> 17,952,830 part/sec
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/partition-rec-demo.cc"
/// End:

