
#include "comb/permlex.h"

#include "comb/fact2perm.h"
#include "perm/perminvert.h"

#include "comb/printperm.h"
#include "comb/printmixedradix.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "demo/nextarg.h"


//% Generate all permutations in lexicographic order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 4;
    NXARG(n, "Permutations of n elements.");
    bool dfz= true; // whether to print dots for zeros

    perm_lex P(n);
#ifdef TIMING
    while ( P.next() )  {;}
#else
    const ulong *x = P.data();
    ulong *t = new ulong[n];
    ulong ct = 0;
    do
    {
        cout << setw(4) << ct << ":";
        ++ct;

        P.print("    ", dfz);

        make_inverse(x, t, n);
        print_perm("    ", t, n, dfz);

        perm2ffact(x, n, t);
        print_mixedradix("    ", t, n-1, dfz);

        cout << endl;
    }
    while ( P.next() );
#endif

    return 0;
}
// -------------------------

/*
Timing:
time ./bin 13
./bin 13  54.86s user 0.30s system 99% cpu 55.192 total
 ==> 13!/54.86 == 113,507,488 permutations per second

time ./bin 12
arg 1: 12 == n  [Permutations of n elements.]  default=4
./bin 12  4.22s user 0.02s system 99% cpu 4.251 total
 ==> 12!/4.22 == 113.507.488  permutations per second
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/permlex-demo.cc"
/// End:

