
#include "comb/permminchange.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "demo/nextarg.h"


//% Generate all permutations in minimal-change order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 4;
    NXARG(n, "Permutations of n elements.");
    bool piq = 0;
    NXARG(piq, "Option: print internal data.");
    bool dfz = true;  // whether to print dots for zeros

    perm_minchange P(n);

#ifdef TIMING
    while ( P.next() ) {;}
#else
    ulong ct = 0;
    do
    {
        cout << setw(4) << ct << ":";
        ++ct;

        P.print("    ", dfz);

        ulong sw1, sw2;
        P.get_swap(sw1, sw2);
        cout << "    (" << sw1 << ", " << sw2 << ") ";

        P.print_inv("    ", dfz);

        if ( piq )
        {
            cout << "    d= ";
            for (ulong i=0; i<n; ++i)  cout << (P.d_[i]==1 ? '+' : '-' ) << " ";

            cout << "  ii= ";
            for (ulong i=0; i<n; ++i)  cout << P.ii_[i] << " ";
        }

        cout << endl;
    }
    while ( P.next() );
#endif

    return 0;
}
// -------------------------


/*
Timing:
time ./bin 12
./bin 12  5.47s user 0.03s system 100% cpu 5.508 total
 ==> 12!/ 5.508 == 86,964,705 permutations per second
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/permminchange-demo.cc"
/// End:

