
#include "comb/permrev.h"

#include "comb/printperm.h"
#include "comb/printmixedradix.h"

#include "fxtio.h"
#include "demo/nextarg.h"
#include "fxttypes.h"

//#include "perm/perminvert.h"


//% Permutations by prefix reversions, CAT algorithm.

//#define TIMING // uncomment to disable printing



int
main(int argc, char **argv)
{
    ulong n = 4;
    NXARG(n, "Number of elements to permute");
    bool dfz= true; // whether to print dots for zeros

    perm_rev P(n);
    P.first();
//    P.last();

    ulong ct = 0;
    do
    {
        ++ct;
#ifndef TIMING
        cout << setw(4) << ct << ":";
        P.print("    ", dfz);
        print_mixedradix("    ", P.d_, n-1, dfz);
        cout << endl;
#endif
    }
    while ( P.next() );
//    while ( P.prev() );


    cout << endl;
    cout << " ct=" << ct << endl;
    cout << endl;

    return 0;
}
// -------------------------

/*
Timing:
 time ./bin 12
 ct=479001600
./bin 12  4.23s user 0.02s system 99% cpu 4.249 total
 ==> 479001600/4.23 ==  113,239,148 permutations per second

*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/permrev-demo.cc"
/// End:

