
#include "comb/permrot.h"
#include "perm/perminvert.h"
// demo-include "perm/perminvert.cc"

#include "perm/permq.h"

#include "comb/printperm.h"

#include "aux1/copy.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "jjassert.h"

#include "demo/nextarg.h" // NXARG()

//% All permutations, by rotations (cyclic shifts).

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 4;
    NXARG(n, "Number of elements");
    bool dfz= true; // whether to print dots for zeros

    perm_rot P(n);
    const ulong *x = P.data();

    ulong *xi = new ulong[n];  // inverse permutation
//    ulong *a = new ulong[n-1];  // mixed radix number
    ulong *t = new ulong[n];  // aux
    ulong ndt = 0;  // number of transitions that are no derangements
    ulong ct = 0;
    do
    {
#ifndef TIMING
        cout << setw(4) << ct << ":";
        P.print("    ", dfz);

        make_inverse(x, xi, n);
        print_perm("    ", xi, n, dfz);

        if ( ct>0 )
        {
            if ( !is_derangement(x, t, n) )
            {
                cout << " N";
                ++ndt;
            }
        }
        for (ulong j=0; j<n; ++j)  t[j] = x[j];

        cout << endl;
#endif
        ++ct;
    }
    while ( P.next() );
    cout << " # non-derangement transitions = " << ndt << endl;

    cout << " num = " << ct << endl;

    return 0;
}
// -------------------------

/*
Timing:
time ./bin 12
arg 1: 12 == n  [Number of elements]  default=4
 num = 479001600  // == 12!
./bin 12  12.77s user 0.06s system 99% cpu 12.837 total
 ==> 37,509,913 permutations/sec
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/permrot-demo.cc"
/// End:

