
#include "comb/subset-debruijn.h"

#include "comb/printset.h"

#include "fxttypes.h"
#include "fxtiomanip.h"
#include "demo/nextarg.h"


//% Generate all subsets in De Bruijn order.

//#define TIMING // uncomment to disable printing

#define ZEBRA_HACK()  { for(ulong j=0; j<n; j+=2)  x[j]^=1UL; }

int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "Size of the set");
    bool zq = 0;
    NXARG(zq, "Option: alternative order");

    subset_debruijn sdb(n);

    for (ulong j=0; j<=n; ++j)  sdb.next();  // cosmetics: end with empty set
#ifdef TIMING
    while ( sdb.next() )  {;}

#else // TIMING
    ulong *x = (ulong *)sdb.data();  // non-const to allow zebra hack
    ulong ct = 0;
    do
    {
        if ( zq )  ZEBRA_HACK();
        cout << "    " << setw(2) << ct << ":";
        ulong num = print_deltaset_as_set("    ", x, n, 1);

        cout << "   #=" << num;
        print_deltaset_as_set("    ", x, n);
        cout << endl;
        if ( zq )  ZEBRA_HACK();

        sdb.next();
    }
    while ( ++ct < (1UL<<n) );
#endif // TIMING

    return 0;
}
// -------------------------

/*
Timing:
% time ./bin 28
arg 1: 28 == n  [Size of the set]  default=5
./bin 28  13.68s user 0.09s system 99% cpu 13.791 total
 ==> 2^28/13.791 == 19,464,538 subsets per second
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/subset-debruijn-demo.cc"
/// End:

