
#include "mod/mod.h"

#include "fxttypes.h"  // ulong

//% Demo of mod_init(): whether (Z/mZ)* is cyclic, maxorder etc.

umod_t mm[] = {
    4, 17, 18, 31, 32, 121, 2047,
    0x3f40f80000000001ULL,
    0x3fffc00000000001ULL,
    0
};

int
main(int argc, char **argv)
{
    if ( argc==1 )
    {
        for (ulong k=0; mm[k]; ++k)
        {
            mod::init(mm[k]);
            mod::print_info();
            cout << endl;
        }
    }
    else
    {
        umod_t m = atol(argv[1]);
        if ( m==0 )  // TEST
        {
            for (umod_t k=2; k<=0x3fff; ++k)
            {
                if ( 0==(k&0x3ff) )  cout << k << endl;
                mod::init(k);
//                mod::print_info(); cout << endl;
            }

            for (umod_t j=2; j<=0x3fff; ++j)
            {
                umod_t k = j + 0xfffff;
                if ( 0==(k&0x3ff) )  cout << k << endl;
                mod::init(k);
//                mod::print_info(); cout << endl;
            }
        }
        else
        {
            for (ulong k=1; (ulong)argc>k; ++k)
            {
                m = atol(argv[k]);
                mod::init(m);
                mod::print_info();
                cout << endl;
            }
        }
    }

    cout << endl;

    return 0;
}
// -------------------------

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/mod"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/mod/modinfo-demo.cc"
/// End:

